/*
	Minimalistic FAT32 library - Creating file example
	Copyright (C) 2009  Avelino Herrera Morales

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include "physical.h"
#include "fat32.h"


fatUnit currentFatUnit;
fatFile currentFatFile;
uint8_t dataBuffer[65536];
uint32_t readed, written;
FILE *f;


int main(int argc, char **argv) {
	if ((f = fopen(argv[1], "r+")) == NULL) {
		perror("fopen");
		return 1;
	}
	deviceSetFile(f);
	if (fatMount(&currentFatUnit) == 1) {
		fatShowDirectoryEntries(&currentFatUnit, 0, currentFatUnit.rootDirectoryCluster);
		fatCreate(&currentFatUnit, &currentFatFile, argv[2], argv[3]);
		if (currentFatFile.status == FAT_FILE_STATUS_OK) {
			uint32_t i;
			printf("'%s' found: size=%u  startCluster=0x%08X\n", argv[3], currentFatFile.size, currentFatFile.startCluster);
			readed = fatRead(&currentFatUnit, &currentFatFile, 0, 65536, dataBuffer);
			printf("readed = %u\n", readed);
			for (i = 0; i < readed; i++)
				putc(dataBuffer[i], stderr);
			if (argc > 4) {
				written = fatWrite(&currentFatUnit, &currentFatFile, 0, strlen(argv[4]), (uint8_t *) argv[4]);
				printf("written = %u\n", written);
			}
		}
		else
			printf("'%s' not found\n", argv[2]);
	}
	fclose(f);
	return 0;
}
