/*
	Minimalistic FAT32 library - Deleting file example
	Copyright (C) 2009  Avelino Herrera Morales

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include "physical.h"
#include "fat32.h"


fatUnit currentFatUnit;
FILE *f;


int main(int argc, char **argv) {
	if ((f = fopen(argv[1], "r+")) == NULL) {
		perror("fopen");
		return 1;
	}
	deviceSetFile(f);
	if (fatMount(&currentFatUnit) == 1) {
		fatShowDirectoryEntries(&currentFatUnit, 0, currentFatUnit.rootDirectoryCluster);
		if (fatDelete(&currentFatUnit, argv[2]))
			printf("'%s' deleted\n", argv[2]);
		else
			printf("'%s' not found\n", argv[2]);
	}
	fclose(f);
	return 0;
}
