/*
	Minimalistic FAT32 library - Physical layer emulation
	Copyright (C) 2009  Avelino Herrera Morales

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <stdio.h>
#include <stdint.h>
#include "physical.h"


uint8_t currentSector[SECTOR_SIZE];
FILE *deviceFile;


uint8_t deviceReadSector(uint32_t index) {
	fseek(deviceFile, index * SECTOR_SIZE, SEEK_SET);
	return (uint8_t) fread(currentSector, 1, SECTOR_SIZE, deviceFile);
}


uint8_t deviceWriteSector(uint32_t index) {
	fseek(deviceFile, index * SECTOR_SIZE, SEEK_SET);
	return (uint8_t) fwrite(currentSector, 1, SECTOR_SIZE, deviceFile);
}


void deviceSetFile(FILE *f) {
	deviceFile = f;
}

